Index: /trunk/gli/buglist/status.txt
===================================================================
--- /trunk/gli/buglist/status.txt	(revision 6001)
+++ /trunk/gli/buglist/status.txt	(revision 6002)
@@ -44,5 +44,5 @@
 Linux, Win98, WinXP
 4b &amp; 4c
-Fixed 11-08-03
+Fixed 11-08-2003
 Known bug. Ensure correct string being written to metadata.xml - "dc.Subject" rather than "dc.Subject and Keywords"
 
@@ -52,5 +52,5 @@
 Unknown
 6
-Fixed 11-08-03
+Fixed 11-08-2003
 Extracted metadata set should be automatically included in all collections, with the user being given the ability to view/hide it. Warnings should be given to the user if hidden extracted metadata exists
 
@@ -60,5 +60,5 @@
 Unknown
 6
-Fixed 11-08-03
+Fixed 11-08-2003
 Programatic refresh of 'Greenstone Collections' folder
 
@@ -68,5 +68,5 @@
 Unknown
 6
-Fixed 18-08-03
+Fixed 18-08-2003
 Current metadata set schema easily extended to include subfields - complete. You can now add elements within other elements. A GUI representation more difficult - a Tree/Table hybrid is being considered.
 
@@ -76,5 +76,5 @@
 Unknown
 6
-Fixed 11-08-03
+Fixed 11-08-2003
 Show popup tooltips over appropriate row in metadata table
 
@@ -92,5 +92,5 @@
 Unknown
 6
-Fixed 11-08-03
+Fixed 11-08-2003
 The indexes design view has now be changed to be consistant with other views (including the index view for mgpp type indexes)
 
@@ -132,5 +132,5 @@
 Unknown
 6
-Fixed 21-08-03
+Fixed 21-08-2003
 bug#1 Format commands not always updated after change. Redesign format view to be like other views. bug#2 if local library server used, format commands only processed once when server.exe run. Actions added to allow external callers to force collection refresh/reload
 
@@ -140,5 +140,5 @@
 Unknown
 6
-Fixed - 22-10-03
+Fixed 22-10-2003
 Default strings for all features to be added by way of a combobox containing currently/commonly used format strings. Turns out that one multipurpose default format string can be used. Added 'Use Default Format' button to format manager which becomes active when a part is selected that has a default format string available
 
@@ -156,5 +156,5 @@
 Unknown
 6
-Fixed 21-08-03
+Fixed 21-08-2003
 Ensure UNICode compliance. Replace " with &amp;quot; where necessary
 
@@ -228,5 +228,5 @@
 Linux, Win98, WinXP
 NA
-Fixed 22-08-03
+Fixed 22-08-2003
 OK
 
@@ -308,5 +308,5 @@
 Linux, Win98, WinXP
 NA
-Fixed (16-10-03)
+Fixed 16-10-2003
 Error checking increased. Also make the area for the warning message a little larger (made it a textarea rather than a label). Tried several combinations of things (ie missing col file, corrupt lock file) and it didn't 'crap out completely'
 
@@ -324,5 +324,5 @@
 Linux, Win98, WinXP
 NA
-Fixed 22-10-03
+Fixed 22-10-2003
 Include 'expand text' button for extracted metadata. Investigate other methods for displaying HTML based information. Expand text button in place
 
@@ -380,5 +380,5 @@
 Win98, Win2000
 6
-Fixed (16-10-03)
+Fixed 16-10-2003
 Fixed during the recoding of the languages part of the design manager
 
@@ -396,5 +396,5 @@
 Win98, Win2000
 6
-Fixed - 22-10-03
+Fixed 22-10-2003
 Ensure GLI correctly detects when it needs to produce hfiles. Elements in metadata sets can now be told if they are to generate hfiles as necessary, however of the three mentioned above only AZList was a bug. Organization has a flat structure so doesn't really need a Hierarchy classifier (a AZCompactList would do)
 
@@ -404,5 +404,5 @@
 Win98, Win2000
 6
-Fixed - 22-10-03
+Fixed 22-10-2003
 Will show elements in standard ordering according to metadata set (as for metadata table)
 
@@ -428,5 +428,5 @@
 Win98, Win2000
 6
-Fixed (16-10-03)
+Fixed 16-10-2003
 Ensure that selecting a fixed feature clears component selection and adjusts output state appropriately. It was, the problem lay in trying to change the gui from within the EventThread again - SwingUtilities to the rescue.
 
@@ -436,5 +436,5 @@
 Win98, Win2000
 6
-Fixed (16-10-03)
+Fixed 16-10-2003
 First index should be the default if none other is selected. Fixed as part of the redesign of the indexes page
 
@@ -460,5 +460,5 @@
 Win98, Win2000
 6
-Fixed 27-08-03
+Fixed 27-08-2003
 GLI now splits the progress bar on the number of documents in the collection, rather than the number of folders in the collection. This results in more accurate progress measurement.
 
@@ -516,5 +516,5 @@
 Linux
 3.1
-Fixed - 25-10-03
+Fixed 25-10-2003
 Caused by same failed equals check which prevents DLS collections importing metadata under certain conditions
 
@@ -524,5 +524,5 @@
 Linux
 6
-Fixed - 28-10-03
+Fixed 28-10-2003
 OK<br>Turned out one of the debug statements would NPE if index didn't exist.
 
@@ -532,6 +532,6 @@
 Linux
 6
-Pending
-Ensure consistancy between message during import/build
+Fixed 24-11-2003
+Ensure consistancy between message during import/build<br>Now a failure in installCollection() will result in a collection preview unavailable message, rather than a collection successful message
 
 203B068
@@ -668,6 +668,6 @@
 Win2000
 4c4
-Pending
-Possibly a repeat of 203B006 - Search and browse on dc.Subject fail. Increase error checking when designing collection
+Fixed 24-11-2003
+Possibly a repeat of 203B006 - Search and browse on dc.Subject fail. Increase error checking when designing collection<br>I now believe that this is the 'one failed index causes entire collection to become unusable' problem. This is causes by something with a two pass build failing in the first pass, the second pass subsequently killing the entire build because it can't find files that were meant to be generated by the first.
 
 203B084
@@ -724,6 +724,6 @@
 WinME
 4a4
-Pending
-To investigate further.<br>Make selecting icons easier, especially crazy icons relative to _httpcollection_
+Fixed 24-11-2003
+To investigate further.<br>Make selecting icons easier, especially crazy icons relative to _httpcollection_<br>Browse buttons have now been added for selecting images - which automatically handles collection relative paths, although it does this by always copying the image to the images folder of your collection
 
 203F091
@@ -772,5 +772,5 @@
 Linux, WinME, Win2000
 6
-Fixed 13-08-03
+Fixed 13-08-2003
 Discovered filters not using pattern matching at all. Current pattern matching only allows exact matches, whereas a is less than, is greater than etc is needed. Replaced regular expression matching with custom string matcher. Works well for examples like "equal to a*" or "less than */2003", but has interesting behaviour when matching filters set as "b*y"; "bay" and "boy" are equal, "bee" and "bus" are less than while "buz" is greater than
 
@@ -868,6 +868,6 @@
 Win*
 NA
-Pending
-Due to gsdlsite.cfg file not existing yet (server.exe must be run at least once). GLI script should check that the gsdlsite.cfg file exists before starting.
+Fixed 20-11-2003
+Due to gsdlsite.cfg file not existing yet (server.exe must be run at least once). GLI script should check that the gsdlsite.cfg file exists before starting.<br>Server.exe has been modified, and is now run once by the install program to create the necessary config file
 
 203B109
@@ -884,6 +884,6 @@
 All
 NA
-Pending
-Ensure collection changes correctly update title bar<br>Problem is collection hasn't opened successfully. Prevent areas becoming enabled when they shouldn't have
+Fixed 24-11-2003
+Ensure collection changes correctly update title bar<br>Problem is collection hasn't opened successfully. Prevent areas becoming enabled when they shouldn't have<br>GLI now correctly determines when a collection has failed to open, and uder the particular circumstances that lead to the above error (a missing or corrupt collect.cfg file) not only doesn't partially load the collection, but also provides a more helpful error message explaining what has gone wrong
 
 203B111
@@ -900,5 +900,5 @@
 All
 NA
-Fixed 22-08-03
+Fixed 22-08-2003
 Replaced typical open dialog with simplier one showing only installed collections. Current file dialog is accessible via a "Browse" button.
 
@@ -908,5 +908,5 @@
 All
 NA
-Fixed 22-08-03
+Fixed 22-08-2003
 Fix custom filter code
 
@@ -916,5 +916,5 @@
 All
 NA
-Fixed 18-08-03
+Fixed 18-08-2003
 Wasn't firing appropriate event
 
@@ -924,5 +924,5 @@
 All
 NA
-Fixed 21-08-03
+Fixed 21-08-2003
 See 203B017. Remove 'live' updating, and add Replace button
 
@@ -964,5 +964,5 @@
 All
 NA
-Fixed 19-08-03
+Fixed 19-08-2003
 Added 'Abstract' attribute to plugins/classifiers allowing them not to be shown as available to be added (still have access to their arguments though)
 
@@ -972,5 +972,5 @@
 All
 NA
-Fixed 15-08-03
+Fixed 15-08-2003
 Ensure disabling MGPP also disables MPGG specific commands
 
@@ -980,5 +980,5 @@
 All
 NA
-Fixed 19-08-03
+Fixed 19-08-2003
 View now has typical add/replace/remove buttons
 
@@ -988,5 +988,5 @@
 All
 NA
-Fixed 21-08-03
+Fixed 21-08-2003
 When checking what actions should be available, ensure that the current node is non-null
 
@@ -996,5 +996,5 @@
 All
 NA
-Fixed 26-09-03
+Fixed 26-09-2003
 Fixed counting algorithm
 
@@ -1004,6 +1004,6 @@
 All
 NA
-Pending
-Have GDMDocument check if it has content before writing itself out to a metadata.xml
+Fixed
+Have GDMDocument check if it has content before writing itself out to a metadata.xml<br>GDMDocuments are now only written out if they contain at least one description set
 
 203F126
@@ -1092,5 +1092,5 @@
 Mac
 NA
-Fixed 19-08-03
+Fixed 19-08-2003
 Was purposefully shortening description
 
@@ -1140,5 +1140,5 @@
 All
 NA
-Fixed 21-08-03
+Fixed 21-08-2003
 Check if necessary index files exist, rather than remembering if GLI has built the collection before
 
@@ -1156,5 +1156,5 @@
 All
 NA
-Fixed 28-08-03
+Fixed 28-08-2003
 The "Hunt" and "Mirror" views have been re-enabled and updated.
 
@@ -1164,5 +1164,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Quirk of JComboboxes
 
@@ -1172,5 +1172,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Ensured add/remove also changed list of available plugins
 
@@ -1180,5 +1180,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Slight change in terminology of XML report being produced by classinfo.pl (ClasInfo -> ClassInfo)
 
@@ -1188,5 +1188,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Colour flag started with wrong value (true instead of false)
 
@@ -1196,5 +1196,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Language names are now shown
 
@@ -1204,5 +1204,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Spaces work fine. When writing out files values wrapped in " if they contained spaces. Forgot to remove when reading back in and you quickly ended up with lines in the collect.cfg looking like this: classify AZList -button_name """""""""Hello there"""""""""
 
@@ -1212,5 +1212,5 @@
 All
 NA
-Fixed 21-08-03
+Fixed 21-08-2003
 Ensure initial state of buttons, and changes of state
 
@@ -1236,5 +1236,5 @@
 All
 NA
-Fixed 21-08-03
+Fixed 21-08-2003
 Add tif and bmp file extensions to image filter
 
@@ -1276,5 +1276,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Add 'add all metadata' button which adds all elements to the index list with their default name (ie ex.Title -> "Title")
 
@@ -1284,5 +1284,5 @@
 All
 NA
-Fixed 29-08-03
+Fixed 29-08-2003
 Add an replace ability
 
@@ -1308,5 +1308,5 @@
 All
 NA
-Fixed 27-08-03
+Fixed 27-08-2003
 Use panel to fill out extra space so download job progress bars are all the same size
 
@@ -1316,6 +1316,6 @@
 All
 NA
-Pending
-Ensure workflow tab settings validated when collection changed
+Fixed 25-11-2003
+Ensure workflow tab settings validated when collection changed<br>That wasn't the problem - I was caching the results of calls to get configuration settings (for efficiency) but forgot to empty the cache when collections changed. Hmm, thats the second time caching has got me into trouble (re DOMProxyListModel)
 
 203B166
@@ -1324,6 +1324,6 @@
 All
 NA
-Fixed
-File Association manager should be requesting information on how to launch the file (check if it is failing silently).
+Pending
+File Association manager should be requesting information on how to launch the file (check if it is failing silently)<br>There is still a problem under windows where extra speech marks are wrapped around the command
 
 203B167
@@ -1332,6 +1332,6 @@
 All
 NA
-Pending
-GLI incorrectly using accumulate/overwrite flags
+Fixed 25-11-2003
+GLI incorrectly using accumulate/overwrite flags<br>This turned out to be bigger than Ben Hur. The problem is by the time it came to adding metadata to the document, you didn't know whether it had been called by an append or a replace. In order to distinguish between the two I had to add an extra piece of data to all MSMEvents regarding metadata - and in some cases this came down to a best guess depending on where it had been called (such as when dealing with undo methods, which fortunately are no longer called).
 
 203B168
@@ -1340,6 +1340,6 @@
 All
 NA
-Pending
-Race condition between table builder and metadata manager
+Fixed
+Race condition between table builder and metadata manager<br>This buggy behaviour was 'fixed' by the code to ensure a certain row is selected in the table. While the table may still have indeterminate state during its build, the final refresh caused by selecting a different table row generally brings things up to date.
 
 203B169
@@ -1364,5 +1364,5 @@
 All
 NA
-Fixed 4-11-2003
+Fixed 04-11-2003
 It should. Ensure mouse events being correctly processed.
 
@@ -1372,5 +1372,5 @@
 All
 NA
-Fixed - 15-10-03
+Fixed 15-10-2003
 Replace is not hooked up to listeners properly<br>It is now!
 
@@ -1940,5 +1940,5 @@
 All
 NA
-Pending
+Fixed
 Increase empty string checking
 
@@ -1948,5 +1948,5 @@
 All
 NA
-Nothing to do
+Pending
 Caused by spinner loosing focus if it also goes nonvisible at the same time. If focus lost while visible appropriate behaviour maintained
 
@@ -1997,5 +1997,5 @@
 NA
 Pending
-Partitions generate more indexes, but my current system doesn't correctly calculate how many indexes are going to be built (indexes * partitions * languages)
+Partitions generate more indexes, but my current system doesn't correctly calculate how many indexes are going to be built (indexes * partitions * languages)<br>The mentioned fix has been implemented, but the Phind fix is on hold until I find out how we are going to handle multilingual import and build scripts (whereapon the sentinel values I'm looking for are going to be gone)
 
 203B313
@@ -2036,6 +2036,6 @@
 All
 NA
-Pending
-I'm not sure why the correct events aren't being fired - but it seems to happen specifically with folders being brought into collections (not files)
+Fixed 25-11-2003
+I'm not sure why the correct events aren't being fired - but it seems to happen specifically with folders being brought into collections (not files)<br>Still don't know what was causing this but Michaels refresh speed-ups seem to have made the problem go away
 
 203B318
@@ -2052,5 +2052,5 @@
 All
 NA
-Fixed
+Pending Again
 Make memory use reasonable<br>Reinstated the idea of caching metadata.xml files rather than trying to load them all
 
@@ -2156,4 +2156,5 @@
 All
 NA
+Pending
 Think about it
 
@@ -2163,4 +2164,5 @@
 All
 NA
+Pending
 Think about it
 
@@ -2170,4 +2172,5 @@
 All
 NA
+Pending
 Fix
 
@@ -2177,11 +2180,29 @@
 All
 NA
-Think about it
+Pending
+Think about it<br>You're going to have to add a smiley so I know what tone you're taking with this comment!
 
 203B336
+Saving a collection causes the inherited metadata icons to disappear
+NZDL
+All
+NA
+Fixed 25-11-2003
+Ensure inheritance data isn't being stompped, and if not determine why repainting table doesn't repaint icons<br>The problem occured because the pre-save metadata 'purge' wasn't being called (I'd obviously added an extra boolean argument, but had forgotten to increase the number in the call. Worse still this was an overrided method and one of the other methods happened to match!)
+
+203B337
+Importing metadata from legacy files currently requires GDMLoader and a large cache. This has to change if we want to avoid the Out Of Memory problem on large collections
+NZDL
+All
+NA
+Pending
+Was reinstated for legacy collection importing. Need to move the namespace adding code to its own pre-load stage where it gets completed before the GDMManager is loaded.
+
+203B338
 Need to add help text for new features: opening legacy collections, exporting to cdrom.
 NZDL
 All
 NA
+Pending
 Do it.
 
@@ -2191,4 +2212,4 @@
 Non-windows
 NA
+Pending
 Fix.
-