Index: trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 6057)
+++ trunk/gli/src/org/greenstone/gatherer/collection/CollectionManager.java	(revision 6061)
@@ -49,4 +49,5 @@
 import org.greenstone.gatherer.cdm.CollectionMeta;
 import org.greenstone.gatherer.cdm.CollectionMetaManager;
+import org.greenstone.gatherer.collection.BasicCollectionConfiguration;
 import org.greenstone.gatherer.collection.Collection;
 import org.greenstone.gatherer.collection.SaveCollectionTask;
@@ -300,5 +301,5 @@
 		if(collection.msm.getSets().size() == 0) {
 		    Gatherer.println("As there are no metadata sets loaded yet, we'll make special checks for the collections available on the GS2.39CD.");
-		    CollectionConfiguration col_con = new CollectionConfiguration(new File(base_collection_directory, Utility.CONFIG_DIR));
+		    BasicCollectionConfiguration col_con = new BasicCollectionConfiguration(new File(base_collection_directory, Utility.CONFIG_DIR));
 		    // If the source collection is one of the 'big five' then we know what the metadata set is.
 		    String collection_name = col_con.getName();
Index: trunk/gli/src/org/greenstone/gatherer/collection/DeleteCollectionPrompt.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/collection/DeleteCollectionPrompt.java	(revision 6057)
+++ trunk/gli/src/org/greenstone/gatherer/collection/DeleteCollectionPrompt.java	(revision 6061)
@@ -44,4 +44,5 @@
 import org.greenstone.gatherer.Dictionary;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.collection.BasicCollectionConfiguration;
 import org.greenstone.gatherer.collection.Collection;
 import org.greenstone.gatherer.gui.ModalDialog;
@@ -226,5 +227,5 @@
 		    File config_file = Utility.findConfigFile(collections[i]);
 		    if (config_file != null) {
-			CollectionConfiguration config = new CollectionConfiguration(config_file);
+			BasicCollectionConfiguration config = new BasicCollectionConfiguration(config_file);
 			if (config != null) {
 			    CollectionEntry col = new CollectionEntry(collections[i].getName(), config);
@@ -336,7 +337,7 @@
 
 	private String name = null;
-	private CollectionConfiguration config = null;
-
-	public CollectionEntry(String name, CollectionConfiguration config) {
+	private BasicCollectionConfiguration config = null;
+
+	public CollectionEntry(String name, BasicCollectionConfiguration config) {
 	    this.name = name;
 	    this.config = config;
Index: trunk/gli/src/org/greenstone/gatherer/collection/ExportCollectionPrompt.java
===================================================================
--- trunk/gli/src/org/greenstone/gatherer/collection/ExportCollectionPrompt.java	(revision 6057)
+++ trunk/gli/src/org/greenstone/gatherer/collection/ExportCollectionPrompt.java	(revision 6061)
@@ -47,4 +47,5 @@
 import org.greenstone.gatherer.Dictionary;
 import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.collection.BasicCollectionConfiguration;
 import org.greenstone.gatherer.collection.Collection;
 import org.greenstone.gatherer.gui.ModalDialog;
@@ -342,5 +343,5 @@
 		    File config_file = Utility.findConfigFile(collections[i]);
 		    if (config_file != null) {
-			CollectionConfiguration config = new CollectionConfiguration(config_file);
+			BasicCollectionConfiguration config = new BasicCollectionConfiguration(config_file);
 			if (config != null) {
 			    CollectionEntry col = new CollectionEntry(collections[i].getName(), config);
@@ -472,7 +473,7 @@
 
 	private String name = null;
-	private CollectionConfiguration config = null;
-
-	public CollectionEntry(String name, CollectionConfiguration config) {
+	private BasicCollectionConfiguration config = null;
+
+	public CollectionEntry(String name, BasicCollectionConfiguration config) {
 	    this.name = name;
 	    this.config = config;