Index: trunk/gli/classes/xml/import.xml
===================================================================
--- trunk/gli/classes/xml/import.xml	(revision 6096)
+++ trunk/gli/classes/xml/import.xml	(revision 6097)
@@ -1,15 +1,17 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE Info [<!ELEMENT Info (Name,Desc,Arguments)>
-<!ELEMENT Arguments (Option*)>
-<!ELEMENT Option (Name,Desc,Type,Required,Default?,List?)>
-<!ATTLIST Option hide CDATA ''>
-<!ELEMENT Name (#PCDATA)>
-<!ELEMENT Desc (#PCDATA)>
-<!ELEMENT Type (#PCDATA)>
-<!ELEMENT Required (#PCDATA)>
-<!ELEMENT Default (#PCDATA)>
-<!ELEMENT List (Value*)>
-<!ELEMENT Value (Name,Desc?)>
+<!DOCTYPE Info [
+  <!ELEMENT Info      (Name, Desc, Arguments)>
+  <!ELEMENT Arguments (Option*)>
+  <!ELEMENT Option    (Name, Desc, Type, Required, Range, Default?, List?)>
+  <!ELEMENT Name      (#PCDATA)>
+  <!ELEMENT Desc      (#PCDATA)>
+  <!ELEMENT Type      (#PCDATA)>
+  <!ELEMENT Required  (#PCDATA)>
+  <!ELEMENT Range     (#PCDATA)>
+  <!ELEMENT Default   (#PCDATA)>
+  <!ELEMENT List      (Value*)>
+  <!ELEMENT Value     (Name, Desc?)>
 ]>
+
 <Info>
   <Name>import.pl</Name>
@@ -18,18 +20,18 @@
     <Option>
       <Name>archivedir</Name>
-      <Desc>Where the converted material ends up</Desc>
+      <Desc>{import.achivedir}</Desc>
       <Type>string</Type>
       <Required>no</Required>
     </Option>
-    <!--<Option hide="true">
+    <Option>
       <Name>collectdir</Name>
-      <Desc>Collection directory</Desc>
+      <Desc>Collection directory.</Desc>
       <Type>string</Type>
       <Required>no</Required>
       <Default>/research/jmt12/gsdl/collect</Default>
-    </Option>-->
+    </Option>
     <Option>
       <Name>debug</Name>
-      <Desc>Print imported text to STDOUT</Desc>
+      <Desc>Print imported text to STDOUT.</Desc>
       <Type>flag</Type>
       <Required>no</Required>
@@ -37,34 +39,31 @@
     <Option>
       <Name>faillog</Name>
-      <Desc>Fail log filename. This log receives the filenames of any
-        files which fail to be processed (defaults to &lt;collectdir&gt;/colname/etc/fail.log)</Desc>
+      <Desc>Fail log filename. This log receives the filenames of any files which fail to be processed.</Desc>
       <Type>string</Type>
       <Required>no</Required>
-      <Default>&lt;collectdir>/colname/etc/fail.log</Default>
+      <Default>&lt;collectdir&gt;/colname/etc/fail.log</Default>
     </Option>
     <Option>
       <Name>groupsize</Name>
-      <Desc>Number of import documents to group into one XML file</Desc>
+      <Desc>Number of import documents to group into one XML file.</Desc>
       <Type>int</Type>
+      <Required>no</Required>
+      <Default>1</Default>
+    </Option>
+    <Option>
+      <Name>gzip</Name>
+      <Desc>Use gzip to compress resulting xml documents (don't forget to include ZIPPlug in your plugin list when building from compressed documents).</Desc>
+      <Type>flag</Type>
       <Required>no</Required>
     </Option>
     <Option>
-      <Name>gzip</Name>
-      <Desc>Use gzip to compress resulting xml documents (don't forget
-        to include ZIPPlug in your plugin list when building from
-        compressed documents)</Desc>
-      <Type>flag</Type>
+      <Name>importdir</Name>
+      <Desc>Where the original material lives.</Desc>
+      <Type>string</Type>
       <Required>no</Required>
     </Option>
-    <!--<Option hide="true">
-      <Name>importdir</Name>
-      <Desc>Where the original material lives</Desc>
-      <Type>string</Type>
-      <Required>no</Required>
-    </Option>-->
     <Option>
       <Name>keepold</Name>
-      <Desc>Will not destroy the current contents of the archives
-        directory (the default)</Desc>
+      <Desc>Will not destroy the current contents of the archives directory (the default).</Desc>
       <Type>flag</Type>
       <Required>no</Required>
@@ -72,5 +71,5 @@
     <Option>
       <Name>maxdocs</Name>
-      <Desc>Maximum number of documents to import</Desc>
+      <Desc>Maximum number of documents to import.</Desc>
       <Type>int</Type>
       <Required>no</Required>
@@ -78,12 +77,5 @@
     <Option>
       <Name>OIDtype</Name>
-      <Desc>The method to use when generating unique identifiers for
-        each document. &quot;hash&quot; (the default) hashes the
-        contents of the file and so will be the same every time the
-        collection is imported. &quot;incremental&quot; is a simple
-        document count and so will be significantly faster than
-        &quot;hash&quot;. It is not guaranteed to always assign the same
-        identifier to a given document though and does not allow further
-        documents to be added to existing xml archives</Desc>
+      <Desc>The method to use when generating unique identifiers for each document.</Desc>
       <Type>enum</Type>
       <Required>no</Required>
@@ -91,20 +83,23 @@
         <Value>
           <Name>hash</Name>
+          <Desc>Hashes the contents of the file. Document identifier will be the same every time the collection is imported.</Desc>
         </Value>
         <Value>
           <Name>incremental</Name>
+          <Desc>A simple document count that is significantly faster than "hash". It is not guaranteed to always assign the same identifier to a given document though and does not allow further documents to be added to existing xml archives.</Desc>
         </Value>
       </List>
+      <Default>hash</Default>
     </Option>
     <Option>
       <Name>out</Name>
-      <Desc>Filename or handle to print output status to. The default is STDERR</Desc>
+      <Desc>Filename or handle to print output status to.</Desc>
       <Type>string</Type>
       <Required>no</Required>
+      <Default>STDERR</Default>
     </Option>
     <Option>
       <Name>removeold</Name>
-      <Desc>Will remove the old contents of the archives directory --
-        use with care</Desc>
+      <Desc>Will remove the old contents of the archives directory -- use with care.</Desc>
       <Type>flag</Type>
       <Required>no</Required>
@@ -112,6 +107,5 @@
     <Option>
       <Name>sortmeta</Name>
-      <Desc>Sort documents alphabetically by metadata for building. This
-        will be disabled if groupsize > 1</Desc>
+      <Desc>Sort documents alphabetically by metadata for building. This will be disabled if groupsize &gt; 1.</Desc>
       <Type>string</Type>
       <Required>no</Required>
@@ -119,17 +113,24 @@
     <Option>
       <Name>statsfile</Name>
-      <Desc>Filename or handle to print import statistics to. The
-        default is STDERR</Desc>
+      <Desc>Filename or handle to print import statistics to.</Desc>
       <Type>string</Type>
       <Required>no</Required>
+      <Default>STDERR</Default>
     </Option>
     <Option>
       <Name>verbosity</Name>
-      <Desc>A number between zero and three that controls how much
-        information about the process is printed to the standard error
-        stream; 0 gives a little, 3 gives lots</Desc>
+      <Desc>Controls the quantity of output. 0=none, 3=lots.</Desc>
       <Type>int</Type>
+      <Required>no</Required>
+      <Range>0,3</Range>
+      <Default>2</Default>
+    </Option>
+    <Option>
+      <Name>language</Name>
+      <Desc>Language to display option descriptions in (eg. 'en_US' specifies American English). Requires translations of the option descriptions to exist in the perllib/strings_language-code.rb file.</Desc>
+      <Type>string</Type>
       <Required>no</Required>
     </Option>
   </Arguments>
 </Info>
+