Index: trunk/gli/classes/dictionary.properties
===================================================================
--- trunk/gli/classes/dictionary.properties	(revision 6150)
+++ trunk/gli/classes/dictionary.properties	(revision 6166)
@@ -129,5 +129,5 @@
 CDM.ClassifierManager.Classifier_Exists:That classifier has already been assigned for this collection.
 CDM.ClassifierManager.Classifier_Str:classifier
-CDM.ClassifierManager.Classifier_XML_Parse_Failed:GLI has been unable to determine the arguments for the {0}\nclassifier.  Please ensure that the classifier in question\nprovides the  -xml flag by running the classinfo.pl script\nsimilar to the  description of the  pluginfo.pl  script in\nsection   2.1  of   the   Greenstone   Developers   Guide.
+CDM.ClassifierManager.Classifier_XML_Parse_Failed:Unable to determine the arguments for the {0}\nclassifier.  Please ensure that the classifier in question\nprovides the  -xml flag by running the classinfo.pl script\nsimilar to the  description of the  pluginfo.pl  script in\nsection   2.1  of   the   Greenstone   Developers   Guide.
 CDM.ClassifierManager.Configure:Configure Classifier
 CDM.ClassifierManager.Configure_Tooltip:Change the options of the selected classifier
@@ -168,5 +168,5 @@
 CDM.General.Collection_Name:Collection title:
 CDM.General.Collection_Name_Tooltip:Name of the collection
-CDM.General.Copy_Image:In order to use this image for your collection\nGLI must copy into the images folder. Proceed?
+CDM.General.Copy_Image:In order to use this image for your collection\nfiles must be copied into the images folder. Proceed?
 CDM.General.Email.Creator:Creator's Email
 CDM.General.Email.Creator_Tooltip:E-mail address of the collection's creator
@@ -273,5 +273,5 @@
 CDM.PlugInManager.PlugIn_Exists:That plugin has already been assigned for this collection.
 CDM.PlugInManager.PlugIn_Str:plugin
-CDM.PlugInManager.PlugIn_XML_Parse_Failed:GLI has been unable to determine the arguments for the {0}\nplugin. Please ensure that the plugin in question provides\nthe  -xml flag by running the pluginfo.pl script described\nin  section  2.1  of  the   Greenstone  Developers  Guide.
+CDM.PlugInManager.PlugIn_XML_Parse_Failed:Unable to determine the arguments for the {0}\nplugin. Please ensure that the plugin in question provides\nthe  -xml flag by running the pluginfo.pl script described\nin  section  2.1  of  the   Greenstone  Developers  Guide.
 CDM.PlugInManager.Remove:Remove Plugin
 CDM.PlugInManager.Remove_Tooltip:Remove the selected plugin from the list
@@ -373,5 +373,5 @@
 CollectionManager.Missing_Config:This collection does not have a valid collect.cfg file 
 CollectionManager.Not_Col_File:'{0}' is not a Librarian Interface Collection File (.col)
-CollectionManager.Old_Collection:GLI has detected that this is an older version Greenstone collection.\nCurrently these cannot be opened directly, but support for importing\nlegacy collections will be provided soon.
+CollectionManager.Old_Collection:This is an older version Greenstone collection.\nCurrently these cannot be opened directly, but support for importing\nlegacy collections will be provided soon.
 CollectionManager.Preview_Ready_Failed:An error has occured which will prevent the collection being previewed.
 CollectionManager.Preview_Ready_Title:Collection Preview State.
@@ -825,6 +825,6 @@
 #*********************
 #
-MSM.Legacy.Corrupt_Metadata_XML:GLI has encountered a corrupt metadata file while attempting\nto import this legacy collection.  The offending file can be\nfound at:\n{0-Corrupt file path}
-MSM.Legacy.Delete_Metadata_XML:By cancelling the previous dialog you are instructing GLI to\nignore the current legacy metadata file:\n{0-Legacy metadata file path}\nThis is  necessary as you have  provided no safe way for GLI\nimport the metadata contained within.  Are you sure you want\nto do this?
+MSM.Legacy.Corrupt_Metadata_XML:Corrupt metadata file encountered while attempting\nto import this legacy collection.  The offending file can be\nfound at:\n{0-Corrupt file path}
+MSM.Legacy.Delete_Metadata_XML:If you cancel this dialog, the current legacy metadata file\nwill be ignored. Continue?
 MSM.No_Description:No description found.
 MSM.No_Name:No name found.
@@ -918,5 +918,5 @@
 NewCollectionPrompt.Set_Contains:This metadata set contains the elements
 NewCollectionPrompt.Title:Create a new Collection.
-NewCollectionPrompt.Title_Clash:The title you have chosen for your collection is already in use. Should GLI assign this title?
+NewCollectionPrompt.Title_Clash:The title you have chosen for your collection is already in use. Continue?
 NewCollectionPrompt.Title_Error:The title field must be filled out. Please correct.
 #***** New Folder Prompt *****
@@ -1022,5 +1022,5 @@
 #
 #***** TitleClash *****
-TitleClashes.Message:The title you have chosen for your collection is already in use. Should GLI assign this title?
+TitleClashes.Message:The title you have chosen for your collection is already in use. Continue?
 TitleClashes.Title:Entered Title Clashes
 #**********************