Index: trunk/greenorg/macros/reportSuva.dm
===================================================================
--- trunk/greenorg/macros/reportSuva.dm	(revision 6192)
+++ trunk/greenorg/macros/reportSuva.dm	(revision 6192)
@@ -0,0 +1,32 @@
+package report-Suva
+
+_content_ {
+
+<h2>UNESCO Pacific Regional Training Workshop on Greenstone Digital Library Software</h2>
+
+<h3>24-26 November 2003, University of the South Pacific, Suva, Fiji</h3>
+
+<p>
+A UNESCO Pacific regional training workshop on the Greenstone Digital Library Software was conducted at the Library of the University of the South Pacific, Suva, Fiji, from 24-26 November 2003. This international workshop was planned and supported by the UNESCO Communication and Information programme to promote the development and sharing of digital library collections using the Greenstone software. 
+<p>
+Greenstone is a suite of software for building and distributing digital library collections. It provides a new way of organizing information and publishing it on the Internet or on CD-ROM. It is open-source software, issued under the terms of the GNU General Public License. It is produced by the New Zealand Digital Library Project at the University of Waikato, and developed and distributed in cooperation with UNESCO and the Human Info NGO. The aim of Greenstone is to empower users, particularly in universities, libraries and other public service institutions, to build their own digital libraries. More details of the software and example digital libraries built using the software is available at http://www.greenstone.org.
+<p>
+Use of Greenstone internationally is growing very rapidly. Increasing activity on the Greenstone mailing lists is an indication of its growing popularity. Wide varieties of digital collections have been developed, including historical, educational, cultural, and research collections, in several languages. UNESCO is promoting Greenstone with the goal of enabling public service institutions to deploy digital libraries for sharing public domain information. 
+<p>
+The Fiji workshop was attended by 15 participants from 7 countries in the Pacific region: Fiji, Marshall Islands, Papua New Guinea, Samoa, Solomon Islands, Tonga, and Vanuatu. Most of the participants were librarians and library systems personnel from national and educational institutions in these countries. The workshop was designed and conducted by members of the New Zealand Digital Library project. The content was based on an earlier workshop at NCSI, Indian Institute of Science; however, the newly-available Librarian Interface was used as the primary means of interacting with Greenstone. 
+<p>
+The workshop covered the following aspects of Greenstone: overview of features, capabilities, and applications; platforms, installation, and configuration; using the Greenstone Librarian Interface to build collections and add and use metadata; advanced features of the Librarian Interface; sample collections; multilingual support; new interface languages. Most of the presentation and demonstration sessions were followed by laboratory sessions where the participants experimented with the package through carefully designed exercises. During the lab sessions, each participant built a small Greenstone collection of images about tourism in their home country, downloaded from the Web, with manually assigned metadata. At the end of the workshop these were all placed on a self-installing Greenstone CD-ROM entitled Pacific Tourism, and copies were made for participants to take away as a memento.
+<p>
+Each participant had a dedicated workstation with the Windows XP operating system. Apart from the printed course material, Greenstone and associated software were distributed to the participants on CD-ROM. The version of Greenstone that was used was a preliminary edition of the December 2003 release of Greenstone (Version 2.41).
+<p>
+Course evaluation forms were used to assess the effectiveness of presentations and lab exercises. Participants were asked to evaluate the presentations on a five-point scale (very poor, poor, fair, good, very good) in terms of pace, clear speech, helpful examples, approachability, and an overall rating. For the lab sessions, the parameters were: suitable material, help available, clarity of assignments, and appropriate difficulty, and an overall rating. Overall, presentations received grade points ranging from 3 (fair) to 5 (very good), with the majority being 4 and 5; the overall average was 4.2. The pattern was similar for the labs, which also received an overall rating of 4.2.
+<p>
+Based on formal and informal feedback from the participants, the workshop was successful in imparting a conceptual and practical understanding of the use of Greenstone for developing digital collections. There was a consensus that further time was needed to cover all the features of Greenstone that participants wanted to learn about, and many expressed interest in a more advanced follow-up workshop. However, opinion was split as to whether any additional time should be spent in presenting new information or reinforcing existing material through more lab exercises. In fact, it might be useful to divide attendees on the basis of their prior knowledge and experience and run parallel sessions.
+<p>
+All course material (slightly revised to correct minor errors that were discovered during the workshop) will be made available on the Greenstone web site for others to use in future workshops.
+<p>
+Ian H. Witten<br>
+New Zealand Digital Library Project<br>
+1 December 2003
+
+}